// clavierPS2 + ecranLCD 6*2



//3 servos
#include <Servo.h>
Servo regulateur;
Servo droite;
Servo gauche;
int delais=300; //delais pour les servos
int attente=2000; // delais entre chaque lettre
String message;

// 1 clavier
#include <PS2Keyboard.h>
const int DataPin = 4;
const int IRQpin =  3;
PS2Keyboard keyboard;


// 1 ecran LCD 2 ligne 16 carac
#include <LiquidCrystal.h>
const int rs = 12, en = 11, d4 = 7, d5 = 8, d6 = 9, d7 = 10;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

byte smiley[8] = {
  B00000,
  B10000,
  B10000,
  B11111,
  B00101,
  B00101,
  B00100,
  B00100,
};


void setup() {

  lcd.begin(16, 2);
  lcd.setCursor(0,0);
  lcd.clear();
    lcd.createChar(0, smiley);
  // Print a message to the LCD.
 
 
  
  //Serial.begin(9600);
  delay(3000);
 keyboard.begin(DataPin, IRQpin, PS2Keymap_French);
//  Serial.println("Keyboard initialisation ok");
  
//  while (!Serial) {;} // en attente de communication serie
  lcd.clear();
  lcd.print("init servos");  
  
  regulateur.attach(0);
  droite.attach(1);
  gauche.attach(2);
  
  lcd.clear();
  lcd.print("regulateur"); 
  regulateur.write(90);
  delay(delais+1000);
 
  lcd.clear();
  lcd.print("droite    ");
  droite.write(90);
  delay(delais+1000);

  
  lcd.clear();
  lcd.print("gauche     ");
  gauche.write(90);
  delay(delais+1000);
   lcd.clear();
   lcd.setCursor(0,1);
   lcd.print("Touitez ici     ");
   lcd.setCursor(13,1);
   lcd.write(byte(0));
   delay(delais+1000);
}

void bouge(int r,int g,int d)
// fonction qui bouge les servo regulateur, gauche et droite en fonction des angles {0°, 45°,90°,135° et 180°}
// les delais sont compris
{
  regulateur.write(r);
  delay(delais*2);

  gauche.write(g);
  delay(delais);

  droite.write(d);
  delay(attente);
}

void signe(char lettre)
// fonction d'association des angles des 3 servo pour chaque lettres
{
  switch(lettre){
      case 'a':
      case 'à':
      case 'A':
          bouge(90,180,0);
          break;
      case 'b':
      case 'B':
          bouge(135,180,90);
          break;
      case 'c':
      case 'C':
          bouge(0,180,0);
          break;
      case 'd':
      case 'D':
          bouge(45,0,180);
          break;
      case 'e':
      case 'é':
      case 'è':
      case 'ê':
      case 'E':
          bouge(90,0,180);
          break;
      case 'f':
      case 'F':
          bouge(135,0,180);
          break;
      case 'g':
      case 'G':
          bouge(0,0,180);
          break;
      case 'h':
      case 'H':
          bouge(45,180,0);
          break;
      case 'i':
      case 'I':
          bouge(90,0,0);
          break;
      case 'j':    
      case 'J':
          bouge(180,90,90);
          break;
      case 'k':
      case 'K':
          bouge(135,0,90);
          break;
      case 'l':
      case 'L':
          bouge(0,0,0);
          break;
      case 'm':
      case 'M':
          bouge(45,90,0);
          break;
      case 'n':
      case 'N':
          bouge(90,180,180);
          break;
      case 'o':
      case 'O':
          bouge(135,180,180);
          break;
      case 'p':
      case 'P':
          bouge(0,180,180);
          break;
      case 'q':
      case 'Q':
          bouge(45,18,180);
          break;
      case 'r':
      case 'R':
          bouge(90,180,90);
          break;
      case 's':
      case 'S':
          bouge(135,180,90);
          break;
      case 't':
      case 'T':
          bouge(0,180,90);
          break;
      case 'u':
      case 'ù':
      case 'U':
          bouge(45,90,180);
          break;
      case 'v':
      case 'V':
          bouge(90,90,180);
          break;
      case 'w':
      case 'W':
          bouge(135,90,180);
          break;
      case 'x':
      case 'X':
          bouge(0,90,180);
          break;
      case 'y':
      case 'Y':
          bouge(45,180,90);
          break;
      case 'z':
      case 'Z':
          bouge(90,90,0);
          break;
      case '0':
          bouge(0,0,0);
          break;
      case '9':
          bouge(180,180,180);
          break;      
      case '5':
          bouge(90,90,90);
          break;
      
      default:
    //    Serial.print("erreur signe");
      case ' ':
       // Serial.println(lettre);
        bouge(0,90,90); // full vertical
        break;    
  }
}

void loop() {
  //  while (Serial.available()==0){} // attente de buffer serial

  
  if (keyboard.available()) {
    // read the next key
    char c = keyboard.read();
 
    // check for some of the special keys
      if (c == PS2_ENTER) {
       lcd.setCursor(0,1);
         for(int i =0; i<message.length();i++){ // pour toute les lettres du message
    //        Serial.print(message[i]);
            lcd.setCursor(i,1);
            lcd.print("^");
            delay(delais);
            signe(message[i]);
          }
      //    Serial.println(" fin du message.");
          lcd.setCursor(0,1);
          message="";
          
          for(int i =0;i<20;i++){
          lcd.print("    ENVOI OK    ");          
          delay(100);
          lcd.clear();
          delay(50);
          
          }
   lcd.setCursor(0,1);
   lcd.print("Touitez ici     ");
   lcd.setCursor(13,1);
   lcd.write(byte(0));

      } 
      else{
        //Serial.println(message.length());
        if (message.length()<16){
         message+=c;
        }
         lcd.setCursor(0, 0);
        //Serial.print(c);
        lcd.print(message);
      }  
      }
  }



